unit UMisc;

{$mode objfpc}{$H+}
{$ASMMODE intel}

interface

uses
  Classes, SysUtils; 

function fpcReplacementExp(v: Double): Double; assembler;
{Nur die Exponentialfunktion...
 Neudeklaration erforderlich, da das in fpc eingebaute
 exp() (aus unerfindlichen Gründen) zweimal das Kontroll-
 wort des Coprozessors speichert und wieder lädt.
 Ergebnis: exp()-i386 in fpc ist ein wenig lahm...}

implementation

function fpcReplacementExp(v: Double): Double; assembler;
asm
  fld qword ptr [v]
  fldl2e
  fmulp ST(1), ST(0)
  fld ST(0)
  frndint
  fxch ST(1)
  fsub ST(0), ST(1)
  f2xm1
  fld1
  faddp ST(1), ST(0)
  fscale
  fstp ST(1)
end;

end.

